/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#pragma once

#include "DataProvider.h"
#include <string>
#include <vector>

namespace mirai
{

class Task;

class Event
{

  public:
	Event(data_provider *provider, event_data data) : _provider(provider), _data(data) {};

	std::string title() const;
	Date date() const;
	Time starts_at() const;
	Time ends_at() const;

	std::vector<Task> query_tasks() const;

	void set_title(const std::string &newTitle);
	void set_date(const Date &date);
	void set_start_time(const Time &time);
	void set_end_time(const Time &time);

	int id() const;
	int source_id() const;

  private:
	event_data _data;
	data_provider *_provider;
};

} // namespace mirai
