/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#pragma once

#include "DataProvider.h"
#include "DateTime.h"
#include "Event.h"
#include <optional>
#include <string>

namespace mirai
{

class Day;

class Task
{

  public:
	Task(data_provider *data, task_data task) : data_(data), task_(task) {};

	std::string title() const;
	mirai::task_state state() const;
	bool checked() const;
	bool has_due_date() const;
	std::optional<Date> due_date() const;

	void set_title(const std::string &newTitle);
	void set_date(const Date &date);
	void set_checked(bool checked);
	void unschedule();

	int id() const;
	int source_id() const;

  private:
	task_data task_;
	data_provider *data_;
};

} // namespace mirai
